<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        body {
            background-color: black;
            color: white;
            margin: 60px;
            font-family: Arial, Helvetica, sans-serif;
        }
        .cmd {
            font-family: monospace;
            color: green;
            font-size: large;
        }

        .result {
            font-family: monospace;
            color: gold;
            font-size: large;
        }      
    </style>
</head>
<body>
    

<h3>IMAGENES OFICIALES</h3>
<p>Al ser Docker ya una herramienta conocida y muy usada, los provedores de servicios open source (Apache, PHP, Mongo) crearon sus imagenes oficiales para ser usadas en Docker.</p>
<p>Para descargar una imagen oficial es por medio del comando <span class="cmd">docker pull</span></p>
<br>
<p><span class="tip">Nota</span> Se versionan las images por medio de tags</p>

<h4>¿Como crear imagen personalizada?</h4>
<ol>
    <li>Crear una carpeta donde se va a guardar la imagen</li>
    <li>Crear el DockerFile <br>
        FROM centos:7 ------- Primer instrucción que define el sistema sobre el que va a correr la imagen (también hay imagenes oficiales)
        RUN yum install httpd -y ------ Comando para instalar apache en centos (el comando depende del sistema operativo definido en la primer línea FROM) -y significa afirmativo para todo en la instalación de apache
    </li>
    <li>Posterior a la creación del Dockerfile se debe ejecutar el comando <span class="cmd">docker build --tag etiqueta-ejemplo .</span> que es un comando para construir imagenes tomando como base un Dockerfile definiendo su tag con la etiqueta <em>--tag etiqueta-ejemplo</em> el punto en el comando no es accidental, es para definir que trabaje con el Dockerfile previamente creado.</li>
    <li><span class="cmd">docker images | grep etiqueta-ejemplo</span> para listar las imagenes con un nobre especifico</li>
</ol>

<p><span class="cmd">docker history - H etiqueta-ejemplo:latest</span> Para mostrar los detalles de la creación de la imagen </p>

<p>Para probar la imagen recien creada se debe crear un container a partir de etiqueta-ejemplo</p>
<p> <span class="cmd">docker run -d etiqueta-ejemplo</span> pero al ejecutar este comando el container no se podrá levantar porque se requiere que en el Dockerfile se agregue el CMD quedando el contenido del Dockerfile de la siguiente manera.</p>

<pre>
    FROM centos:7
    RUN yum install httpd -y
    CMD apachectl -DFOREGROUND --- comando para ejecutar apache en primer plano
</pre>

<p>Se debe construir de nuevo la imagen para que contenga los nuevos cambios del CMD del DockerFile con el comando <span class="cmd">docker build -t etiqueta-ejemplo:apache-cmd-agregado .</span></p>
<p>Una vez agregado el CMD al Dokerfile se ejecuta de nuevo el comando <span class="cmd">docker run -d --name unNombre etiqueta-ejemplo:apache-cmd-agregado</span></p>
<p>Se elimina el container previamente creado para evitar un conflicto por duplicidad con el comando <span class="cmd">docker rm -fv apache</span></p>
<p>Se ejecuta de nuevo el comando pero ahora se pasa como argumento la imagen con el CMD agregado <span class="cmd">docker run -d etiqueta-ejemplo:apache-cmd-agregado</span>.</p>
<p><span class="cmd">docker ps</span> Para listar los contenedores que están activos</p>
<p><span class="cmd">docker ps -a</span> Para listar los contenedores que están inactivos</p>
<p><span class="cmd">docker ps -l</span> Muestra el último contenedor creado</p>



<p><span class="cmd">docker run -d --name unNombre -p 80:80 etiqueta-ejemplo:apache-cmd-agregado</span> Después del nombre del contenedor se puede agregar <b>-p puertoMaquinaLocal:puertoContendedor</b> para que se pueda acceder via web</p>

<p><span class="cmd">docker rm -fv nombre_container</span> elimina un contenedor</p>

<h2>DOCKERFILE</h2>
<p>Puede contener:</p>
<ul>
    <li>FROM</li>
    <li>RUN</li>
    <li>COPY/ADD</li>
    <li>ENV</li>
    <li>WORKDIR</li>
    <li>EXPOSE</li>
    <li>LABEL</li>
    <li>USER</li>
    <li>VOLUME</li>
    <li>CMD</li>
</ul>

<h3>Resumen de creación de primer container</h3>
<ol>
    <li>Crear Dockerfile:

        <pre>
            FROM centos:7
            RUN yum install httpd -y
            CMD apachectl -DFOREGROUND
        </pre>
    </li>
    <li>Dentro del mismo directorio (images) se ejecuta en la terminal el comando <span class="cmd">docker build --tag apache-centos .</span> para crear la imagen a partir del <em>Dockerfile</em> definido en el paso 1</li>
    <li>Una vez descargados los paquetes y creada la imagen se mostrará un mensaje en la consola <span class="result">Successfully tagged apache-centos:latest</span> que indica que se creó la imagen con éxito y para verificarlo se puede ejecutar el comando <span class="cmd">docker images | grep apache-centos</span> que mostrará las imagenes que coincidan con ese nombre.</li>
    <li>Adicional a ésto si se desean conocer más detalles de la composición de una imagen se puede ejecutar el comando <span class="cmd">docker history -H apache-centos:latest</span></li>
    <li>Para crear un container a partir de una imagen se debe ejecutar el comando <span class="cmd">docker run -d --name apache apache-centos:latest</span>
        <br>
        Si se desea visualizar el server via HTTP se puede agregar el puerto <span class="cmd">docker run -d --name apache -p 80:80 apache-centos:latest</span>
        
    </li>
</ol>


<h2>Mostrar sitio personalizado en mi nuevo container</h2>

<ol>
    <li>Primero se debe crear un Dockerfile agregando la accion de COPY/ADD definiendo la ruta donde se encuentra el código fuente y la ruta dentro del container en donde se albergará el código fuente que en el caso de apache es <b>/var/www/html</b> <br>
    
        <pre>
            FROM centos:7
            RUN yum install httpd -y
            COPY album /var/www/html
            CMD apachectl -DFOREGROUND
        </pre>    
    </li>
    <li>Reconstruir la imagen para que ejecute la accíon de copiar el código fuente en la carpeta del container con el comando <span class="cmd">docker build --tag nuevo-sitio .</span></li>
    <li>Una vez generada la nueva imagen y agregado el código a la carpeta de apache se ejecuta el comando <span class="cmd">docker run -d --name apache -p 80:80 nuevo-sitio:latest</span></li>
    <li>Finalmente se da refresh a la página de localhost:80</li>
</ol>



<hr>
<h2>ENV variable de entorno en Dockerfile</h2>
<ol>
    <li>Se debe crear el Dockerfile con el siguiente contenido: <br>
        <pre>
            FROM centos:7   &#60;== Se define el SO del servidor
            RUN yum install httpd -y &#60;== Se instala apache
            COPY album /var/www/html &#60;== Crea una copia del código fuente a un carpeta del apache
            ENV contenido prueba &#60;== Crea la variable de entorno
            RUN  echo "$contenido" > /var/www/html/prueba.html &#60;== vacia el contenido de la variable en un documento html
            CMD apachectl -DFOREGROUND &#60;== corre el servicio de apache en segundo plano
        </pre>
    </li>
    <li>Se crea la imagen con las nuevas instrucciones definidas en el Dockerfile con el comando <span class="cmd">docker build -t apache-centos .</span></li>
    <li>Se elimina el container previamente creado con el comando <span class="cmd">docker rm -fv apache</span></li>
    <li>Se crea el nuevo container con el comando <span class="cmd">docker run -d --name apache -p 80:80 apache-centos:latest</span></li>
    <li>Se refresca la página de localhost:80 y se ingresa al sitio localhost:80/prueba.html</li>
</ol>


<hr>
<h2>WORKDIR predefinición de rutas en el Dockerfile</h2>
<p>¿Cómo definir un workdir?</p>
<ol>
    <li>Se crea el Dockerfile usando la siguiente sintaxis <br>
        <pre>
            FROM centos:7   &#60;== Se define el SO del servidor
            RUN yum install httpd -y &#60;== Se instala apache
            <b>WORKDIR /var/www</b> &#60;== Predefine la ruta del entorno de apache donde se guara el código fuente
            COPY album html &#60;== Crea una copia del código fuente a un carpeta del apache (se omite WORKDIR /var/www ya que se definió previamente en el workdir)
            ENV contenido prueba &#60;== Crea la variable de entorno
            RUN  echo "$contenido" > /var/www/html/prueba.html &#60;== vacia el contenido de la variable en un documento html
            CMD apachectl -DFOREGROUND &#60;== corre el servicio de apache en segundo plano
        </pre>
    </li>
    <li>Se crea la imagen con las nuevas instrucciones definidas en el Dockerfile con el comando <span class="cmd">docker build -t apache-centos .</span></li>
    <li>Se elimina el container previamente creado con el comando <span class="cmd">docker rm -fv apache</span></li>
    <li>Se crea el nuevo container con el comando <span class="cmd">docker run -d --name apache -p 80:80 apache-centos:latest</span></li>
</ol>


<p>Una alternativa es definir toda la ruta como se muestra en la siguiente sintaxis y solo usando un punto para definir que el código fuente apunta a directorio actual de trabajo.</p>

<pre>
    FROM centos:7   &#60;== Se define el SO del servidor
    RUN yum install httpd -y &#60;== Se instala apache
    <b>WORKDIR /var/www/html</b> &#60;== Predefine la ruta del entorno de apache donde se guara el código fuente
    COPY album . &#60;== Crea una copia del código fuente a un carpeta del apache (se omite WORKDIR /var/www ya que se definió previamente en el workdir)
    ENV contenido prueba &#60;== Crea la variable de entorno
    RUN  echo "$contenido" > /var/www/html/prueba.html &#60;== vacia el contenido de la variable en un documento html
    CMD apachectl -DFOREGROUND &#60;== corre el servicio de apache en segundo plano
</pre>

<hr>
<h2>EXPOSE abre un puerto para su posterior uso</h2>
<p>Nota: para ser utilizado un puerto diferente definido con EXPOSE se deben realizar configuraciones adicionales al apache.</p>


<hr>
<h2>LABEL agrega metadatos a la imagen</h2>
<p>La propiedad label se puede agregar en cualquier punto del Dockerfile solo se debe considerar que si se agrega en las primeras lineas antes de la instalación del apache éste se descargará e instalará de nuevo.</p>

<hr>
<h2>USER permite identificar que usuarios está ejecutando la tarea</h2>
<ol>
    <li>Se crea un Dockerfile con el siguiente contenido</li> <br>
    <pre>
        FROM centos:7
        LABEL version=1.0.3
        LABEL description="Esta es la descripcion de la imagen con apache"
        RUN yum install httpd -y
        COPY album /var/www/html
        RUN echo "$(whoami)" > /var/www/html/user1.html
        RUN useradd FranciscoH
        USER FranciscoH
        RUN echo "$(whoami)" > /tmp/user2.html
        USER root
        RUN cp /tmp/user2.html /var/www/html/user2.html
        CMD apachectl -DFOREGROUND
    </pre>
    <li>Se crea la imagen con las nuevas instrucciones definidas en el Dockerfile con el comando <span class="cmd">docker build -t apache-centos .</span></li>
    <li>Se elimina el container previamente creado con el comando <span class="cmd">docker rm -fv apache</span></li>
    <li>Se crea el nuevo container con el comando <span class="cmd">docker run -d --name apache -p 80:80 apache-centos:latest</span></li> 
    <li>Se accede a la página <b>localhost:80/user1.html</b> y <b>localhost:80/user2.html</b> que muestran respectivamente la palabra user1.html = root y user2.html = FranciscoH.</li>
</ol>

<h2>CMD</h2>
<p>En el CMD no es necesario tener todas las instrucciones se puede crear un script para posteriormente llamarlo desde la propiedad CMD como se muestra en la siguiente sintaxis</p>

<p>Contenido del archivo run.sh</p>
<pre>
    #!/bin/bash
    echo "Iniciando container..."    
    echo "INICIANDO!!!!" > /var/www/html/ini.html
    apachectl -DFOREGROUND
</pre>

<p>Contenido del archivo Dockerfile</p>
<pre>
    FROM centos:7
    LABEL version=1.0.3
    LABEL description="Esta es la descripcion de la imagen con apache"
    RUN yum install httpd -y
    COPY album /var/www/html
    RUN echo "$(whoami)" > /var/www/html/user1.html
    RUN useradd FranciscoH
    USER FranciscoH
    RUN echo "$(whoami)" > /tmp/user2.html
    USER root
    RUN cp /tmp/user2.html /var/www/html/user2.html
    COPY run.sh /run.sh
    CMD sh /run.sh
</pre>

<p>Solo para verificar que se está ejecutando el comando definido en run.sh se puede ejecutar el siguiente comando en la terminal <span class="cmd">docker ps --no-trunc</span> que muestra varias columnas de contenido que en lo particular se debe poner atención la columna de <b>COMMAND</b> que debe mostrar algo como <em>"/bin/sh -c 'sh /run.sh'"</em> </p>
<p>Adicional a ésto se puede ejecutar el comando <span class="cmd">docker logs apache</span> que muestra el echo definido en el script
</p>

<hr>
<h2>.dockerignore ignorar archivos al momento de la construcción de la imagen y el container.</h2>
<p>Dentro de éste archivo solo se deben listar los nombres de los archivos que se desean ignorar</p>


<hr>
<h2>Buenas practicas</h2>
<ul>
    <li>Un contenedor debe ser efimero (fácil de destruir)</li>
    <li>Solo un servicio por cada contenedor</li>
    <li>Altamente recomendable ignorar los archivos que no son indispensables y con mayor razón si su tamaño en el disco es grande con el archivo .dockerignore</li>
    <li>En lo posible  disminuir el número de capas</li>
    <li>Separar argumentos extensos para facilitar su lectura  (con \)</li>
    <li>No instalar paquetes inecesarios</li>
    <li>Se recomienda agregar labels para documentar los containers</li>
    <li>Varios argumentos en una sola capa</li>
</ul>



<h2>EJEMPLO DE IMAGEN CENTOS, APACHE y PHP</h2>
<pre>
    FROM centos:7
    RUN \
    yum -y install httpd php php-cli php-common
    RUN echo "&#60;?php phpinfo(); ?&#62;" &#62; /var/www/html/phpinfo.php
    CMD apachectl -DFOREGROUND
</pre>


<p><b>TRUCO</b> echo "nombreArchivo" &#62;&#62; .dockerignore</p>

<h2>Agregar HTTPS al apache del container</h2>
<ol>
    <li>Comando en terminal para crear un certificado autofirmado: <span class="cmd">openssl req -x509 -nodes -days 365 -newkey rsa:2048 -keyout docker.key -out docker.crt</span> (Solo se da enter a cada configuración sin capturar nada excepto en common... que se debe capturar <b>localhost</b>)</li>
    <li>Se van a generar dos archivos <b>docker.crt</b> y <b>docker.key</b></li>
    <li>Se deben crear dos archivos nuevos un Dockerfile y un ssl.conf con el siguiente contenido:

        <p class="result">Dockerfile</p>
        <pre>
            FROM centos:7
            RUN \
            yum -y install \
            httpd \
            php \
            php-cli \
            php-common \
            mod_ssl \
            openssl
            RUN echo "&#60;?php phpinfo(); ?&#62;" &#60; /var/www/html/phpinfo.php
            COPY album /var/www/html
            COPY docker.crt /etc/httpd/docker.crt
            COPY docker.key /etc/httpd/docker.key
            COPY ssl.conf /etc/httpd/conf.d/default.conf
            EXPOSE 443
            CMD apachectl -DFOREGROUND
        </pre>

        <hr>
        <p class="result">ssl.conf</p>
        <pre>
            &#60;VirtualHost *:443&#62;
                ServerName localhost
                DocumentRoot /var/www/html
                SSLEngine on
                SSLCertificateFile docker.crt
                SSLCertificateKeyFile docker.key
            &#60;/VirtualHost&#62;
        </pre>
    </li>    
    <li>Se crea una nueva imagen basandose en el Dockerfile con el comando <span class="cmd">docker build -t apache-ssl:okssl .</span></li>
    <li>Se crea un nuevo container con el comando <span class="cmd">docker run -d --name apache-ssl -p 443:443 apache-ssl:okssl</span></li>
    <li>Se ingresa a la página https://localhost:443</li>
</ol>

<h2>Cómo eliminar una imagen?</h2>
<p><span class="cmd">docker images</span> lista todas las imagenes creadas</p>
<p><span class="cmd">docker images | grep nombreImagen</span> muestra las imagenes creadas que coincidan con el parametro de búsqueda</p>
<p><span class="cmd">docker rmi [id_imagen | nombre_imagen:tag]</span></p>
<p>Ejemplo: docker rmi centos:prueba centos:prueba1    &#60;== se pueden eliminar dos imagenes con una sola instrucción</p>


<h2>Crear imagen con un Dockerfile de distinto nombre</h2>
<ol>
    <li>Se crea un nuevo Dockerfile con un nombre distinto con el siguiente comando <span class="cmd">vi my-jorgeFile</span> con algun contenido como se muestra a continuación:
        <p class="result">my-jorgeFile</p>
        FROM centos:7
        RUN echo "Hola mundo desde un dockerfile de nombre my-jorgeFile"    
    </li>
    <li>Se crea la imagen con el siguiente comando que es como el que se ha venido utilizando en el curso solo agregando <b>-f my-jorgeFile</b> para definir un nuevo flag <span class="cmd">docker build -t prueba -f my-jorgeFile .</span></li>
    <li>Se crea el container basado en la imagen recien creada con el punto anterior ejecutando el comando <span class="cmd">docker run -d --name prueba-container prueba:latest</span></li>
    <li></li>
</ol>

<h2>Dangling images</h2>
<p>Al ejecutar el comando <span class="cmd">docker images</span> se pueden notar imagenes con el nombre y tag con el dato &#60;none&#62; y estas son las dangling images</p>
<p>Al docker solo tener permisos de lectura sobre las imagenes no puede sobre escribir en la misma imagen los cambios efectuados en el Dockerfile al hacer una nueva construcción y por lo tanto crea una nueva imagen que toma el nombre y tag de la última creada quedando su nombre y tag como &#60;none&#62; pero conservando su hash.</p>
<p>Se puede evitar la creación de las Dangling images especificando un tag distinto en cada construcción de una imagen que se basa en el mismo Dockerfile.</p>
<p><span class="cmd">docker images -f dangling=true</span> Muestra todas las imagenes dangling</p>
<h4>Maneras de eliminar las dangling images</h4>
<ul>
    <li>Modo1(Una por una): <span class="cmd">docker rmi dfe77afe2814</span></li>
    <li>Modo2(Todas): <span class="cmd">docker images -f dangling=true -q | xargs docker rmi</span></li>
</ul>


<h2>Cómo usar Multi-Stage-Build</h2>
<p>Cuando se requiere agregar dependencias desde un segundo from se recomienda usar el Multi-Stage-Build ya que para la construcción de la imagen solo tomará en cuenta los elementos agregados de los otros FROM y el contenido completo del último from definido a contnuación un ejemplo.</p>

<p>Se crearon dos imagenes la primera denominada x2 con un peso total de 267MB y x3 con un peso total de 26.5MB </p>

<p class="result">Dockerfile (x2)</p>
<pre>
    FROM centos:7 as test
    RUN fallocate -l 10M /opt/file1
    RUN fallocate -l 20M /opt/file2
    RUN fallocate -l 30M /opt/file3
</pre>

<p class="result">Dockerfile (x3)</p>
<pre>
    FROM centos:7 as test
    RUN fallocate -l 10M /opt/file1
    RUN fallocate -l 20M /opt/file2
    RUN fallocate -l 30M /opt/file3
    FROM alpine
    COPY --from=test /opt/file2 /opt/myFile
</pre>


<p>RESULTADO</p>
<pre class="result">
    REPOSITORY           TAG       IMAGE ID       CREATED          SIZE
    prueba100            x3        027835cd630b   6 minutes ago    26.5MB
    prueba100            x2        c081e46b761b   13 minutes ago   267MB
</pre>


<p>CONCLUSIÓN: Se dismuinuye considerablemente el tamaño de las imagenes que requieren dependencias de uno o más FROM creadas con la técnica de Multi-Stage-Build.</p>

<hr>
<hr>
<h1>CONTENEDORES</h1>
<hr>
<h3>Información importante sobre los contenedores</h3>
<ul>
    <li>Son una instancia de ejecución de una imagen</li>
    <li>Son temporales (No se recomienda ejecutar cambios en los contenedores ya que son bolatiles)</li>
    <li>Los elementos de los containers solo son de lectura</li>
    <li>Se pueden crear n cantidad de contenedores partiendo solo de una imagen</li>    
</ul>

<p><span class="cmd">docker ps</span> para listar todos los conetenedores activos</p>
<p><span class="cmd">docker ps -a</span> para listar todos los conetenedores definidos</p>
<p><span class="cmd">docker rm -f nombre-container</span> para forzar(-f) la eliminación de un container se requiere forzar la eliminación ya que están en ejecución.</p>


<p>ARGUMENTOS AL CREAR UN CONTAINER</p>
<ul>
    <li><b>-d</b> El container corre en segundo plano</li>
    <li><b>-p</b> Mapeo de puertos del contenedor</li>    
</ul>


<h2>Creacion de multiples contenedores de jenkins</h2>
<ul>
    <li>En primera instacia se debe descargar la imagen oficial del jenkins con el comando <span class="cmd">docker pull jenkins/jenkins</span></li>
    <li>Una vez que se descarga toda la imagen de jenkins se puede cosultar con el comando <span class="cmd">docker images | grep jenkins</span> y se listarán las imagenes que coincida su nombre.</li>
    <li>Ahora es momento de crear el container que corre por el puerto 8080(por defecto) con el comando <span class="cmd">docker run -d --name jenkinsv2 -p 8080:8080 jenkins/jenkins</span></li>
    <li>Para crear el segundo container (puerto 9090) se ejecuta el segundo comando <span class="cmd">docker run -d --name jenkinsv2 -p 9090:8080 jenkins/jenkins</span></li>
    <li>Se puede verificar que ambos containers se encuentren en ejecución con el comando <span class="cmd">docker ps</span> que muestra los containers y sus respectivos puertos.</li>
    <li>Finalmente se ingresa a lás páginas localhost:8080 y localhost:9090 que deben mostrar un sitio identico de la interfaz de Jenkins ya que parten de la misma imagen.</li>
</ul>

<h2>Renombrar container</h2>
<p><span class="cmd">docker rename nombre-actual nuevo-nombre</span></p>

<h2>Detener contenedor</h2>
<p><span class="cmd">docker stop nombre-contenedor | id-contenedor</span></p>

<h2>Activar contenedor</h2>
<p><span class="cmd">docker start nombre-contenedor | id-contenedor</span></p>

<h2>Reiniciar contenedor</h2>
<p><span class="cmd">docker restart nombre-contenedor | id-contenedor</span></p>


<h2>Cómo ingresar al shell del SO del container?</h2>
<ul>
    <li>Se ejecuta el siguiente comando en la terminal <span class="cmd">docker exec -ti nombre-contenedor bash</span> (-ti t=terminal i=interactiva) </li>
    <li>Se puede agregar un <b>-u root</b> después de exec para ingresar a la terminal como root</li>
    <li>Para salir de ésta terminal se debe capturar el comando <span class="cmd">exit</span></li>
</ul>

<h2>Eliminar todos los contenedores</h2>
<div class="cmd">docker ps -q | xargs docker rm -f|</div>

<h2>Variables de entorno</h2>
<ol>
<li>Se crea una variable de entorno desde la imagen con ENV
<div class="result">Dockerfile</div>
<pre>
    FROM centos:7
    ENV prueba 123456
    RUN useradd francisco
</pre>
</li>
<li>Se crea la imagen <span class="cmd">docker build -t entorno .</span></li>
<li>Se crea el container <span class="cmd">docker run -dti --name entorno-cont entorno</span></li>
<li>Para mostrar el alcance de las variables de entorno ingresaremos a la consola del SO centos 7 que corre el container con el comando <spna class="cmd">docker exec -ti entorno-cont bash</spna> y se mostrará un promp como el siguiente <b>[root@c16c92c9de9c /]#</b></li>
<li>Se ejecuta el comando <span class="cmd">echo $prueba</span> que mostrará en la terminal 123456 que se definió desde el Dockerfile</li>
</ol>

<p>Para crear una variable de entorno en el container se puede ejecutar el siguiente comando :</p>
<div class="cmd">docker run -dti -e "variableContainer=1098765" --name entorno-cont-variable entorno</div>
<p>Para visualizar el contenido de la variable se requiere ingresar a la terminal del nuevo container creado por medio del comando <span class="cmd">docker exec -ti entorno-cont-variable bash</span> y una vez que se muestra el promp se ejecuta el comando <span class="cmd">echo $variableContainer</span> para ver el contenido de la variable definida al momento de la creación del container.</p>
<p>Dentro de la terminal del container también se puede ejecutar el comando <span class="cmd">env</span> para listar todas las variables relacionadas.</p>

<h2>Crear container MYSQL</h2>
<ol>
    <li>Se instala MySQL en docker con el comando <span class="cmd">docker pull mysql</span></li>
    <li>Una vez que termina la instalación se ejecuta el comando <span class="cmd">docker run --name primer-mysql -e MYSQL_ROOT_PASSWORD=123456 -d mysql:latest</span> para crear el container de mysql.</li>
    <li>Se puede consultar el log para ver que sucede con la base de datos con el comando <span class="cmd">docker logs -f primer-mysql</span></li>
    <li>Para visualizar todos los detalles del contenedor se puede ejecutar el comando <span class="cmd">docker inspect primer-mysql</span></li>
    <li>Dentro de todo el contenido se puede encontrar la dirección IP de nuestro container</li>
    <li></li>
</ol>




<h2>Para crear una imagen de Ubuntu y ejecutar su terminal</h2>
<div class="cmd">docker run --rm -ti ubuntu bash</div>

<h2>Para instalar el mySql-client en Ubuntu y conectarse a un container de MySQL</h2>
<p>Primero se recomienda actualizar los repositorios con el comando <span class="cmd">apt-get update</span> y posteriormente ejecutar el comando <span class="cmd">apt-get install mysql-client</span></p>
<p>Para conectarse se debe ejecutar el comando <span class="cmd">mysql -u root -h 172.17.0.5 -p123456</span> Nota: Puede cambiar la IP y la contraseña según sea el caso.</p>
<p>Si se conecta con éxito a la BD se debe mostrar un promp como éste <span class="result">mysql&#60;</span> en el cual ya se pueden ejecutar las sentencias de bases de datos.</p>


<h2>Como crear instacia de container que corra en localhost</h2>
<p>Para ésto es necesario hacer un mapeo de puertos en el comando de construcción del container con el siguiente comando se crea el container con los puertos mapeados <span class="cmd">docker run -d -p 3306:3306 --name segundo-mysql -e MYSQL_ROOT_PASSWORD=123456 mysql:latest</span></p>

<h2>Consumo de recursos de un container</h2>
<div class="cmd">docker stats nombre-container</div>

<h2>Container de apache</h2>
<div class="cmd">docker run -d -p 9999:80 --name apache httpd</div>

<h2>Container de nginx</h2>
<div class="cmd">docker run -d -p 8888:80 --name nginx nginx</div>

<h2>Container de tomcat</h2>
<div class="cmd">docker pull tomcat:9.0.8-jre8-alpine</div>
<div class="cmd">docker run -d -p 7070:8080 --name my-tomcat tomcat:9.0.8-jre8-alpine</div>



<h2>Crear container de PostgreSQL</h2>
<div class="cmd">docker pull postgres</div>
<div class="cmd">docker run --name primer-postgres -e "POSTGRES_PASSWORD=123456" -e "POSTGRES_USER=nuevo-usuario" -e "POSTGRES_DB=persona" -d -p 5432:5432 postgres</div>
<p>Se puede ingresar a la consola de postgresql por medio del comando <span class="cmd">docker exec -ti primer-postgres bash</span> y cambiará el prompt</p>
<p>Se captura el comando <span class="cmd">psql -d persona -U nuevo-usuario</span></p>



<p><b>NOTA:</b> Se pueden consultar referencias de ayuda con el comando <span class="cmd">docker run --help | grep palabra-clave</span></p>


<h2>Limitar recursos a un contenedor</h2>
<p>Inicialmente se ejecuta el comando <span class="cmd">docker stats name-container</span> para visualizar los recursos que utiliza el el container como se muestra a continuación:</p>
<pre>
    CONTAINER ID   NAME      CPU %     MEM USAGE / LIMIT     MEM %     NET I/O       BLOCK I/O     PIDS
    a0df9e1f2abf   apache    0.00%     30.76MiB / 7.571GiB   0.40%     4.97kB / 0B   4.46MB / 0B   82
</pre>

<h4>MEMORIA RAM</h4>
<p>Para restringir el la capacidad máxima memoria RAM del container se usa el comando run con los siguientes argumentos <span class="cmd">docker run -d <b>-m "1Gb"</b> -p 9999:80 --name apache httpd</span> de esta manera como máximo se puede usar un 1Gb de almacenamiento de éste container como se muestra a continuación como resultado del comnando <span class="cmd">docker stats apache</span>:</p>
<pre>
CONTAINER ID   NAME      CPU %     MEM USAGE / <span class="result">LIMIT</span>   MEM %     NET I/O       BLOCK I/O   PIDS
1208da2665e9   apache    0.00%     24.08MiB / <span class="result">1GiB</span>     2.35%     5.34kB / 0B   0B / 0B     82
</pre>

<h4>CPU</h4>
<p>Se pueden consultar las caracteŕisticas del CPU de nuestro equipo/servidor por medio del comando <span class="cmd">grep "model name" /proc/cpuinfo
</span> y para saber cúantos cpus son en el hardware se ejecuta el comando <span class="cmd">grep "model name" /proc/cpuinfo | wc -l</span></p>
<p>Con el siguiente comando se crea un container que solo tiene permiso de usar los cpus 0 y 1  <span class="cmd">docker run -d --cpuset-cpus 0-1 -p 9999:80 --name apache-cpus httpd</span></p>
<p><b>NOTA:</b> Algo muy importante a considerar es que los cpus se cuentan desde 0 y por lo tanto queda de la siguente manera si el hardware tuviera 4 cpus</p>

<table>
    <tr>
        <td>CPU1</td>
        <td>Posición 0</td>
    </tr>
    <tr>
        <td>CPU2</td>
        <td>Posición 1</td>
    </tr>
    <tr>
        <td>CPU3</td>
        <td>Posición 2</td>
    </tr>
    <tr>
        <td>CPU4</td>
        <td>Posición 3</td>
    </tr>
</table>

<p>Se pueden combinar las restricciones de uso de recursos en el mismo comando a continuación se creará un comando para crear un container de apache que tiene como límite de memoria RAM 400Mb y permiso de usar los CPUS 1,2 y 3.</p>
<div class="cmd">docker run -d -m "400Mb" --cpuset-cpus 0-3 --name apache-restringido -p 80:80 httpd</div>

<h2>Copiar archivos a un container</h2>
<p>Para éste ejemplo se crea un cotainer de apache con el siguiente comando <span class="cmd">docker run -d --name apache-files -p 80:80 httpd</span></p>
<p>Se crea una carpeta con el comando <span class="cmd">mkdir copiaArchivos</span></p>
<p>Nos posicionamos en la carpeta con el comando <span class="cmd">cd copiaArchivos</span></p>
<p>Se puede tomar un archivo .html o se puede crear uno con el comando <span class="cmd">echo "Hola Mundo :D" > index.html</span></p>
<p>Se copia el nuevo archivo al container de apache con el comando <span class="cmd">docker cp index.html apache-files:/tmp</span></p>
<p>Solo para verificar se ingresa a la terminal del container con el comando <span class="cmd">docker exec -ti apache-files bash</span> y se nos posicionamos en la ruta donde se pegó el archivo con el comando <span class="cmd">cd /tmp</span> y se ejecuta el comando <span class="cmd">ls</span> para mostrar los archivos contenidos dentro de ésta carpeta del container y opcionalmente se puede ejecutar el comando <span class="cmd">cat index.html</span> para ver el contenido del archivo.</p>
<p><b>NOTA</b> El index al que accede por defecto el apache al consultarse via web es <b>/usr/local/apache2/htdocs</b></p>
<p>Si se deseara que lo primero que se vea sea el contenido que agregamos se tiene que copiar a la carpeta htdocs con el siguiente comando <span class="cmd">docker cp index.html apache-files:/usr/local/apache2/htdocs/index.html</span></p>

<h2>Copiar archivos desde el contenedor a una carpeta local</h2>
<p>En casos donde se requiera un archivo desde el container por ejemplo un log se puede ejecutar el comando <span class="cmd">docker cp nombre-container:/var/log/nombrelog.log .</span> (el punto define que quiero que el archivo se copie aquí o se puede definir en otra ruta)</p> 

<h2>Convertir contenedor en una imagen</h2>
<p>A partir de un container existente se ejecuta el siguiente comando <span class="cmd">docker commit nombre-container-actual nombre-imagen-resultante</span> y para crear un container a partir de la imagen resultante se recomienda ejecutar el comando <span class="cmd">docker run -dti --name nuevo-container nombre-imagen-resultante /bin/bash</span></p>

<h2>Sobreescribir CMD de container</h2>
<p>Al agregar parametros adicionales al final del comando para crear el container pasan como elementos del CMD:</p>
<div class="cmd">docker run -d -p 8080:8080 nombre-img-base argumentosAdicionalesCMD<b>Ejemplo: python -m SimpleHTTPServer 8080</b>
</div>

<h2>Destruir contenedores automáticamente</h2>
<p>Si se desea crear un container para que se autodestruya al cerrar la terminal se destruya se ejecuta con el siguiente comando <span class="cmd">docker run --rm -ti --name name-container imagen bash</span></p>

<p><span class="cmd">docker info | grep -i root</span> muestra la ruta del directorio root de docker</p>

<p>El archivo de configuración de Docker se encuentra en <span class="result">/var/lib/docker/docker.service</span> y en la línea de ExecStart se define el direcftorio raíz y para cambiar esto solo es necsesario agregar <b>--data-root nueva-carpeta</b> debe estar creada ésta carpeta y se hace un refresh a la configuración con el comando <span class="cmd">systemctl daemon-reload</span> y a continuación <span class="cmd">systemctl restart docker</span></p>
<p>Si es necesario mover el contenido de la carpeta original previamente se debe detener el servicio con el comando <span class="cmd">sudo systemctl stop docker</span> se puede hacer con el comando <span class="cmd">rm -rf /opt/*</span> para limpiar la carpeta y a continuación de debe mover el contenido con el comando nos posicionamos en la carpeta que contiene la información en la ruta /var/lib/ y se ejecuta el comando <span class="cmd">mv docker/ /nueva-carpeta/</span></p>
<p>Se recomienda verificar que queden correctamente mapeadas las carpetas en el archivo <span class="result">/var/lib/docker/docker.service</span></p>


<hr>
<hr>
<h1>VOLÚMENES</h1>
<hr>
<p>Los volúmenes permiten almacenar data persistente del contendedor y existen tres tipos:</p>
<ul>
    <li>Host</li>
    <li>Anonymus</li>
    <li>Named Volumes</li>
</ul>



<h2>Volúmenes de host</h2>
<p>Éstos guardan la información en una carpeta del equipo local definida por el administrador de docker y a partir de esta se pueden crear más containers con el mismo contenido. Se crea con la siguiente sintaxis <span class="cmd">docker run -d -p 3306:3306 --name mysql-resp -e "MYSQL_ROOT_PASSWORD=123456" <b>-v /ruta/carpeta/local:/var/lib/mysql</b> mysql:5.7</span></p>
<p>Se puede crear el container, eliminar y recrear (definiendo la misma ruta de volumen) para verificar que los datos percisten.</p>

<h2>Volúmenes anónimos</h2>
<p>Éstos guardan la información en una carpeta del equipo local definida por el algoritmo de docker y a partir de esta se pueden crear más containers con el mismo contenido. Se crea con la siguiente sintaxis <span class="cmd">docker run -d -p 3306:3306 --name mysql-resp -e "MYSQL_ROOT_PASSWORD=123456" <b>-v /var/lib/mysql</b> mysql:5.7</span> (solo se define la ruta del container)</p>
<p>Para saber en donde se guardó el volúmen se puede ejecutar el comando que consulta la ruta root de docker <span class="cmd">docker info | grep -i root</span> y dentro de esa ruta se encuentra la carpeta volumes</p>
<p>Se puede crear el container, eliminar y recrear (definiendo la misma ruta de volumen) para verificar que los datos percisten.</p>

<h2>Volúmenes en Dockerfile</h2>
<p>A diferencia de los dos primeros tipos de volúmenes un volumne nombrado se define desde el Dockerfile</p>
<p class="result">Dockerfile</p>
<pre>
    FROM centos
    VOLUME /opt/
</pre>
<p>Este volumen tiene el mismo comportamiento que el volumen anónimo</p>

<p><b>NOTA</b> Se puede verificar el contenido del volumen rastreando en la ruta /var/lib/docker/volumes/9fe5d(hash del volumen)01c01/_data </p>

<p><b>NOTA</b> Al eliminar un container se usa el comando <span class="cmd">docker rm -fv nombre-volumen</span> pero puede variar el argumento -fv si se queda solo la letra -f quiere decir que se forzará la eliminación sin importar que esté en ejecución el container y se puede adicionar la letra <b>v</b> para especificar que también se desea eliminar el o los volúmenes del container en caso de que existan.</p>


<h2>Volúmenes nombrados</h2>
<p>Es la unión de un volumen de host y un volumne anónimo </p>
<p>Para crear un volumen nombrado se utiliza el comando <span class="cmd">docker volume create volume-name</span></p>
<p>Se puede verificar su creación con el comando <span class="cmd">docker volume ls</span></p>
<p>Una vez creado el volumen solo falta relacionarlo a un container y se asigna muy similar a los volúmenes de host con el comando <span class="cmd">ocker run -d -p 3306:3306 --name mysql-resp -e "MYSQL_ROOT_PASSWORD=123456" -v volume-name:/var/lib/mysql  mysql:5.7</span></p>
<p>Para eliminar el volumen se puede ejecutar el comando <span class="cmd">docker volume rm volume-name</span></p>
<p>Se puede recrear el contenedor con la misma información persistente utilizando el mismo comando de la creación</p>


<h2>Dangling volumes</h2>
<p>Con el comando <span class="cmd">docker volume ls -f dangling=true</span> se listan los volúmenes dangling. Por lo tanto se puede decir que no son usados por ningún contenedor.</p>
<p>Para eliminar todos los volúmenes dangling se puede ejecutar el comando <span class="cmd">docker volume ls -f dangling=true -q | xargs docker volume rm</span></p>
<p><span class="result">Utileria</span> Se puede ver el contenido de los archivos dentro de un container sin necesidad de ingresar a su terminal y se puede realizar la consulta por medio del comando <span class="cmd">docker exec nombre-container -c "cat /ruta/archivo.txt"</span></p>

<hr>
<hr>
<h1>REDES</h1>
<hr>
<p>Tipos de redes</p>
<ol>
    <li>Bridge</li>
    <li>Host</li>
    <li>None</li>
    <li>Overlay</li>
</ol>

<h2>Cuál es la red por defecto de Docker?</h2>
<p>Se puede consultar la red de docker con el comando <span class="cmd">ip a | grep docker</span> y muestra como resultado algo similar a:</p>
<pre>
    3: docker0: &#60;NO-CARRIER,BROADCAST,MULTICAST,UP&#62; mtu 1500 qdisc noqueue state DOWN group default 
    inet 172.17.0.1/16 brd 172.17.255.255 scope global docker0
</pre>

<p><b>NOTA:</b> La driver por defecto es bridge (se listan las redes con el comando <span class="cmd">docker network ls | grep bridge</span> )</p>
<p>Se pueden consultar los detalles de la red con el comando <span class="cmd">docker inspect brindge</span></p>
<p>Si no se define una red en la creación de un container se integran a la red por defecto y al pertenecer a la misma red se pueden interconectar los containers.
<p>docker network create mi-red</p>
<p>Se puede definir la red a la que se va a conectar el container por medio del argumento <b>--network nombre-red</b> en el comando <span class="cmd">docker run</span></p>

<p>Una de las ventajas de usar una red definida por el usuario es que se pueden interconectar y hacer pruebas con el nombre del container y no solo con la IP</p>

<p>Se pueden conectar dos containers si están en la misma red definiendolo en la construcción del mismo y tambiés se pueden interconectar si pertenecen a redes distintas con el comando <span class="cmd">docker network connect red-general nombre-container-otra-red</span> lo que hace es agregar una red adicional al container y conserva su red original, esto se puede verificar con el comando <span class="cmd">docker inspect nombre-container</span></p>
<p>Para desconectar un container de una red se puede usar el comando <span class="cmd">docker network disconnect red-general nombre-container-otra-red</span></p>
<p>Para eliminar una red se ejecuat el comando <span class="cmd">docker network rm nombre-red</span> para hacer eso es necesario que no tenga endpoints activos con los containers y si es necesario se puede hacer un stop o eliminarlos para proceder con la eliminación de la red.</p>

<h4>Definir red e IP a container</h4>
<p>Primero se crea la red con el subnet con el comando <span class="cmd">docker network create --subnet 172.128.10.0/24 --gateway 172.128.10.1 -d bridge mi-red</span></p>
<p>A continuación se crea container con el siguiente comando <span class="cmd">docker run --network mi-red --ip 172.128.10.50 -d --name mi-container centos</span></p>

<h4>Crear contenedor en la red del host</h4>
<p>Para que el container no se conecte a la red virtual de docker y en cambio se conecte a la red fisica del host se puede configurar con el siguiente comando <span class="cmd">docker run --network host -d --name mi-container centos</span></p>

<hr>
<hr>
<h1>Docker compose</h1>
<hr>
<p>Permite crear aplicaciones multicontenedor</p>
<p>Intalación de docker compose en linux:</p>
<div class="cmd">sudo curl -L https://github.com/docker/compose/relases/dowload/1.21.2/docker-compose-$(uname -s)-$(uname -m) -o /usr/local/bin/docker-compose</div>


<!-- <div class="cmd">sudo apt-get update</div>
<div class="cmd">sudo apt-get install docker-compose-plugin</div> -->


<!--  
 <p>Para descargar e instalar Compose CLI plugin, ejecutar:</p>
 <div class="cmd">DOCKER_CONFIG=${DOCKER_CONFIG:-$HOME/.docker}</div>
 <div class="cmd">mkdir -p $DOCKER_CONFIG/cli-plugins</div>
 <div class="cmd">curl -SL https://github.com/docker/compose/releases/download/v2.6.1/docker-compose-linux-x86_64 -o $DOCKER_CONFIG/cli-plugins/docker-compose</div>
  -->
<p>Un archivo yml se compone de 4 elementos</p>
<ol>
    <li>version</li>
    <li>services</li>
    <li>volumes</li>
    <li>networks</li>
</ol>

<p>Ejemplo de docker compose:</p>
<div class="result">docker-compose.yml</div>
<pre>
    version: '3'
    services: 
      web:
        container_name: apacheOne
        ports:
          - "8080:80"
        image: httpd
</pre>

<p>Se ejecuta el comando <span class="cmd">docker-compose up -d</span> y para verificar se puede ejecutar el comando <span class="cmd">docker ps</span> para visualizar los contenedores que están activos.</p>
<p>Se eliminan los containers generados por medio de docker-compose con el comando <span class="cmd">docker-compose down</span></p>
<p>Ejemplo de container MYSQL</p>
<div class="result">docker-compose.yml</div>
<pre>
    version: '3'
    services: 
      db:
        image: mysql:5.7
        container_name: BaseDatos
        ports:
          - "3306:3306"
        enviroment: 
          - "MYSQL_ROOT_PASSWORD=123456"
</pre>
<p>También existe el escenario donde las variables de entorno se pueden almacenar en un archivo con la extensión .env como se muestra a continuación:</p>
<div class="result">common.env</div>
<pre>
    MYSQL_ROOT_PASSWORD=123456
</pre>
<hr>
<div class="result">docker-file.yml</div>
<pre>
    version: '3'
services: 
  db:
    image: mysql:5.7
    container_name: BaseDatos
    ports:
      - "3306:3306"
    env_file: common.env
</pre>

<hr>
<h4>Volumen nombrado</h4>
<pre>
    version: '3'
services: 
  web:
    container_name: nginxTwo
    ports:
      - "8081:8080"
    volumes:
      - "vol2:/usr/share/nginx/html"
    image: nginx:latest
volumes:
  vol2:
</pre>

<hr>
<h4>Volume host</h4>
<pre>
    version: '3'
    services: 
      web:
        container_name: nginxTwo
        ports:
          - "8081:8080"
        volumes:
          - "/home/usuario/carpetacompose/html:/usr/share/nginx/html"
        image: nginx:latest    
</pre>

<hr>
<hr>
<h2>Redes en compose</h2>
<hr>
<pre>
    version: '3'
services: 
  web:
    container_name: nginxTwo
    ports:
      - "8081:8080"
    image: nginx:latest
    networks:
      - net-test
networks:
  net-test:
</pre>


<h2>Dos containers con la misma red</h2>
<pre>
    version: '3'
services: 
  web:
    container_name: apache1
    ports:
      - "8081:8080"
    image: httpd:latest
    networks:
      - net-test
  web2:
    container_name: apache2
    ports:
      - "8082:8080"
    image: httpd:latest
    networks:
      - net-test
networks:
  net-test:
</pre>
<p>Se puede hacer ping entre los containers con el comando <span class="cmd">docker exec -ti apache2 bash -c "ping apache1"</span></p>
<p><b>NOTA:</b> Si aparece un error como el siguiente: <b>bash: line 1: ping: command not found</b></p>
<p>Se requiere instalar la utileria de IP con los siguientes comandos</p>
<div class="cmd">apt-get update</div>
<div class="cmd">apt-get install iputils-ping</div>

<h2>Construir imagenes en un compose</h2>
<div class="result">docker-compose.yml</div>
<pre>
    version: '3'
    services:
        web:
            container_name: nginxOne
            image: prueba-web
            build: .
</pre>

<div class="result">Dockerfile</div>
<pre>
    FROM centos:latest
    RUN mkdir /home/debian/Documentos/nuevaCarpeta
</pre>
<p>A continuación se ejecuta el comando <span class="cmd">docker-compose build</span></p>

<h2>Sobreescribir CMD en docker-compose</h2>
<div class="result">docker-compose.yml</div>
<pre>
    version: '3'
    services:
    web:
        image: centos:latest
        command: python -m SimpleHTTPServer 8080
        ports:
            - "8080:8080"
</pre>

<p>Se puede ejecutar un archivo yml con un nombre distinto utilizando el argumento -f como se muestra en el siguiente comando: <span class="cmd">docker-compose -f docker-compose-ejemplo.yml up -d</span></p>

<h2>Limitar recursos de un container en Docker-compose</h2>
<pre>
    version: '3'
    services:
    web:
        container_name: pruebalimitado
        image: nginx:latest
        mem_limit: 20m
        cpuset: "0"
        ports:
            - "8080:8080"
</pre>

<h2>Politica de reinicio de contenedores</h2>
<p>Condiciones en las que un contenedor debería ser reiniciado</p>
<h2>Limitar recursos de un container en Docker-compose</h2>
<pre>
    version: '3'
    services:
    web:
        container_name: pruebalimitado
        image: nginx:latest
        mem_limit: 20m
        cpuset: "0"
        ports:
            - "8080:8080"
        restart: no | on-failure | unless-stoped | always
</pre>
<ol>
    <li>no = valor por defecto el container no se reinicia</li> 
    <li>on-failure = si hay un fallo interno el container se reinicia</li>
    <li>unless-stoped = se va a reiciar el container siempre y cuando el usuario lo detuvo manualmente</li>
    <li>always = siempre se reinicia el container</li>
</ol>

<h2>Cambiar el nombre prefijo de los elementos compose</h2>
<p>Docker compose agrega un prefijo a las redes, volumenes etc y para cambiar este prefijo se usa el argumento -p nombre-prefijo a continuación un ejemplo:
    <span class="cmd">docker-compose <b>-p prefijo</b> up -d</span>  el argumento -p hace referencia a project.</p>

<p>Dentro del archivo docker-compose.yml el argumento <b>Depends on: -db </b> crea una dependencia de servicios que define la regla que primero se debe construir db</p>
    



</body>
</html>